import { __read, __assign } from 'tslib';
import * as React from 'react';
import { useContext, useRef, useMemo } from 'react';
import { LayoutGroupContext } from '../../context/LayoutGroupContext.js';
import { useForceUpdate } from '../../utils/use-force-update.js';
import { nodeGroup } from '../../projection/node/group.js';

var LayoutGroup = function (_a) {
    var children = _a.children, id = _a.id, _b = _a.inheritId, inheritId = _b === void 0 ? true : _b;
    var layoutGroupContext = useContext(LayoutGroupContext);
    var _c = __read(useForceUpdate(), 2), forceRender = _c[0], key = _c[1];
    var context = useRef(null);
    if (context.current === null) {
        if (inheritId && layoutGroupContext.id) {
            id = layoutGroupContext.id + "-" + id;
        }
        context.current = {
            id: id,
            group: nodeGroup(),
        };
    }
    var memoizedContext = useMemo(function () { return (__assign(__assign({}, context.current), { forceRender: forceRender })); }, [key]);
    return (React.createElement(LayoutGroupContext.Provider, { value: memoizedContext }, children));
};

export { LayoutGroup };
